#!/usr/bin/env python3
# -*- coding:utf-8 -*-
import rest_tool
from common import executeCmd, getspecialConfigValue, getDataProviderVersion
from common import downloadDataProvider, instanceUpdateLogger, getUpdateLogger
from common import instanceSpecialConfigJson, isExistThreadRun
import time
import guard
import multiprocessing
import os

class UpdateMonitorThread(multiprocessing.Process):
    def __init__(self, interval):
        multiprocessing.Process.__init__(self)
        self.interval = interval
    
    def run(self):
        logger = getUpdateLogger()
        logger.info("Start to get update Data Provider script")
        while True:
            ###getData
            try:
                dataProviderVersion = getspecialConfigValue("DataProviderVersion",name = 'globalConfig')
                logger.info("DataProviderVersion is %s"%(dataProviderVersion))
                scriptVersion = float(dataProviderVersion.split()[-1])
                obsScriptVersion = getDataProviderVersion(True,logger)
                text = guard.readPythonExecutePath()
                logger.info("obsScriptVersion is %s"%(obsScriptVersion))
                if(scriptVersion < obsScriptVersion):
                    downloadDataProvider(True, logger)
                    instanceUpdateLogger()
                    logger = getUpdateLogger()
                    instanceSpecialConfigJson(logger)
                    dataProviderVersion = getspecialConfigValue("DataProviderVersion",name = 'globalConfig')
                    logger.info("End to get update Data Provider script,script version is %s"%(dataProviderVersion))
                    if(float(dataProviderVersion.split()[-1]) != obsScriptVersion):
                        logger.warning("update failed")
                    else:
                        logger.info("Begin to reinstall")
                        currentDir = os.getcwd()
                        absPathCatelog = os.path.abspath(currentDir)
                        if(text != ""):
                            cmd = "sudo " + absPathCatelog + "/install.sh" + " " + text
                            executeCmd(cmd,isTrip=False)
                        else:
                            cmd = "sudo " + absPathCatelog + "/install.sh"
                            executeCmd(cmd,isTrip=False)
                else:
                    logger.info("Data Provider is up to date, version is %s"%(scriptVersion))
            except Exception,e:
                logger.error('update dataprovider failed')
                logger.error(e)
            time.sleep(self.interval)

if __name__ == '__main__':
    instanceUpdateLogger()
    logger = getUpdateLogger()
    #load SpecialCongifig
    instanceSpecialConfigJson(logger)
    #check thread is Run
    isExist = isExistThreadRun(os.getpid(), getspecialConfigValue("UpdateScript",name = 'globalConfig'))
    if isExist:
        logger.error("The old instance %s is running"%(isExist))
        exit()
    UpdateInterval = int(getspecialConfigValue("UpdateInterval",name = 'globalConfig'))
    updateMonitorThread = UpdateMonitorThread(UpdateInterval)
    updateMonitorThread.start()
    logger.info("Start updateservice ok")
